// https://nuxt.com/docs/api/configuration/nuxt-config
export default defineNuxtConfig({
  ssr: true,
  components: true,
  buildModules: ['@nuxtjs/composition-api/module'],

  env: {
      baseUrl: process.env.BASE_URL || "http://localhost:3000",
  },

  app: {
      buildAssetsDir: "/static/",

      head: {
          link: [
              {
                  rel: "stylesheet",
                  href: "//bbs.gter.net/data/cache/style_2_common.css?Z62",
              },
          ],
          script: [
              {src: "https://app.gter.net/bottom?tpl=header&menukey=ask"},
              {src: "https://app.gter.net/bottom?tpl=footer,popupnotification", body: true},
              {
                  src: "https://bbs.gter.net/static/js/common.js",
                  body: true
              },
              {
                  innerHTML: `
                  window.userInfoWin = {}
                  STYLEID = "2";
                  STATICURL = "static/";
                  IMGDIR = "https://bbs.gter.net/template/archy_plt8/image";
                  VERHASH = "Z62";
                  charset = "gbk";
                  discuz_uid = "0";
                  cookiepre = "4B5x_c0ae_";
                  cookiedomain = "gter.net";
                  cookiepath = "/";
                  showusercard = "1";
                  attackevasive = "0";
                  disallowfloat = "";
                  creditnotice = ",";
                  defaultstyle = "";
                  REPORTURL = "aHR0cDovL2Jicy5ndGVyLm5ldC9mb3J1bS5waHA/dGlkPTI0MDYzNTYmZ290bz1sYXN0cG9zdA==";
                  SITEURL = "https://ask.gter.net/";
                  JSPATH = "static/js/";`,
                  type: "text/javascript",
              },
          ],
      },
  },

  head: {
      meta: [{charset: "utf-8"}, {name: "viewport", content: "width=device-width, initial-scale=1"}, {"http-equiv": "Cache-Control", content: "no-cache, no-store, must-revalidate"}, {"http-equiv": "Pragma", content: "no-cache"}, {"http-equiv": "Expires", content: "0"}],
  },

  devtools: {enabled: true},

  build: {
      loaders: {
          imgUrl: {limit: 10000},
      },
  },

  modules: ['@element-plus/nuxt'],
  compatibilityDate: "2025-03-21",
})